#!python

import math

class calc:
	def __init__ ( self ):
		self.reset ()

	# Reset the calculator.
	def reset ( self ):
		self.dot = 0
		self.sum = 0
		self.func = ''
		self.num = ''

	# Compute a new sum.
	def compute ( self ):
		if self.num:
			if self.func == 'add':
				self.sum += float ( self.num )
			elif self.func == 'sub':
				self.sum -= float ( self.num )
			elif self.func == 'mul':
				self.sum = self.sum * float ( self.num )
			elif self.func == 'div':
				try:
					self.sum = self.sum / float ( self.num )
				except:
					self.sum = 0.0
			else:
				self.sum = float ( self.num )


		self.dot = 0
		self.num = ''
		self.func = ''

	# Erase an input mistake.
	def oops ( self ):
		if self.num:
			if self.num[-1] == '.':
				self.dot = 0
			self.num = self.num[0:-1]

	# Set the function to be used by compute.
	def set_function ( self, f ):
		self.compute ()
		self.func = f

	# Add to end of input.
	def input ( self, i ):
		if i == '.' and not self.dot:
			self.dot = 1
			self.num = self.num + i
		elif i != '.':
			self.num = self.num + i

	# Output the number on the face of the calculator.
	def output ( self ):
		if self.num:
			return self.num
		else:
			return str ( self.sum )

	# Treat number as a percentage.
	def percent ( self ):
		if self.num:
			self.num = str ( float ( self.num ) / 100. )
		elif self.sum:
			self.sum = self.sum / 100.

	# Square of number.
	def square ( self ):
		if self.num:
			self.num = str ( float ( self.num ) ** 2. )
		elif self.sum:
			self.sum = self.sum ** 2.

	# Square root of number.
	def squareRoot ( self ):
		if self.num:
			self.num = str ( math.sqrt ( float ( self.num ) ) )
		elif self.sum:
			self.sum = math.sqrt ( self.sum )

	# Divide 1 by a number.
	def divOne ( self ):
		if self.num:
			self.num = str ( 1. / float ( self.num ) )
		elif self.sum:
			self.sum = 1. / self.sum

	# Input pi.
	def pi ( self ):
		self.num = str ( math.pi )

	# Change the sign of a number.
	def changeSign ( self ):
		if self.num:
			self.num = str ( -1. * float ( self.num ) )
		elif self.sum:
			self.sum = -1. * self.sum
